# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"postal_code": "PostalCode"})
class BillReceiverAddress(BaseModel):
    """Container for additional information for the bill receiver's UPS accounts address.

    :param postal_code: The postal code for the UPS accounts pickup address. The pickup postal code was entered in the UPS system when the account was set-up.  The postal code must be the same as the UPS Bill Receiver account number pickup address postal code. Required for United States and Canadian UPS accounts and/or if the UPS account pickup address has a postal code. If the UPS accounts pickup country or territory is US or Puerto Rico, the postal code is 5 or 9 digits. The character - may be used to separate the first five digits and the last four digits. If the UPS accounts pickup country or territory is CA, the postal code is 6 alphanumeric characters whose format is A#A#A# where A is an uppercase letter and # is a digit , defaults to None
    :type postal_code: str, optional
    """

    def __init__(self, postal_code: str = None):
        if postal_code is not None:
            self.postal_code = postal_code
