# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .credit_card_address import CreditCardAddress


@JsonMap(
    {
        "type_": "Type",
        "number": "Number",
        "expiration_date": "ExpirationDate",
        "security_code": "SecurityCode",
        "address": "Address",
    }
)
class BillShipperCreditCard(BaseModel):
    """Credit card information container.  Required if neither of the following is present:

    /ShipmentRequest/Shipment/PaymentInformation/ShipmentCharge/BillShipper/AccountNumber
    or
    /ShipmentRequest/Shipment/PaymentInformation/ShipmentCharge/BillShipper/AlternatePaymentMethod.

    Credit card payment is valid for shipments without return service only.

    :param type_: Valid values: - 01 = American Express - 03 = Discover - 04 = MasterCard - 05 = Optima - 06 = VISA - 07 = Bravo - 08 = Diners Club - 13 = Dankort - 14 = Hipercard - 15 = JCB - 17 = Postepay - 18 = UnionPay/ExpressPay - 19 = Visa Electron - 20 = VPAY - 21 = Carte Bleue
    :type type_: str
    :param number: Credit Card number.
    :type number: str
    :param expiration_date: Format is MMYYYY where MM is the 2 digit month and YYYY is the 4 digit year.  Valid month values are 01-12 and valid year values are Present Year - (Present Year + 10 years)
    :type expiration_date: str
    :param security_code: Three or four digits that can be found either on top of credit card number or on the back of credit card. Number of digits varies for different type of credit card.  Valid values are 3 or 4 digits. It is required to provide the security code if credit card information is provided and when the ShipFrom countries or territories are other than the below mentioned countries or territories. Argentina, Bahamas, Costa Rica, Dominican Republic, Guatemala, Panama, Puerto Rico and Russia.
    :type security_code: str
    :param address: Container to hold the Credit card Billing Address.  It is required to provide billing address if credit card information is provided and when the ShipFrom country or territory is the US, PR, and CA., defaults to None
    :type address: CreditCardAddress, optional
    """

    def __init__(
        self,
        type_: str,
        number: str,
        expiration_date: str,
        security_code: str,
        address: CreditCardAddress = None,
    ):
        self.type_ = type_
        self.number = number
        self.expiration_date = expiration_date
        self.security_code = security_code
        if address is not None:
            self.address = self._define_object(address, CreditCardAddress)
