# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"code": "Code", "description": "Description"})
class BillingWeightUnitOfMeasurement(BaseModel):
    """Billing weight unit of measurement code. The unit of measurement used in Shipment request is returned.

    :param code: Code of the billing weight measurement units. Values are: KGS or LBS.
    :type code: str
    :param description: Description of the billing weight measurement units., defaults to None
    :type description: str, optional
    """

    def __init__(self, code: str, description: str = None):
        self.code = code
        if description is not None:
            self.description = description
