# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .forward_agent_address import ForwardAgentAddress


@JsonMap(
    {
        "company_name": "CompanyName",
        "tax_identification_number": "TaxIdentificationNumber",
        "address": "Address",
    }
)
class ContactsForwardAgent(BaseModel):
    """The forwarding agent is the company or person acting as agent in the trans-shipping of freight to the destination country or territory.  Applicable for EEI form only.

    :param company_name: Company Name or the Individual name of the Forwarding agent.  Applicable for EEI form only.
    :type company_name: str
    :param tax_identification_number: Tax ID of the Forwarding agent. Valid Values: (Below values are applicable for EEIFilingOption Code =3) 94-308351500  13-168669100     Applicable for EEI form only.
    :type tax_identification_number: str
    :param address: Address information of the Forwarding agent.  Applicable for EEI form only.
    :type address: ForwardAgentAddress
    """

    def __init__(
        self,
        company_name: str,
        tax_identification_number: str,
        address: ForwardAgentAddress,
    ):
        self.company_name = company_name
        self.tax_identification_number = tax_identification_number
        self.address = self._define_object(address, ForwardAgentAddress)
