# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .producer_address import ProducerAddress
from .producer_phone import ProducerPhone


@JsonMap(
    {
        "option": "Option",
        "company_name": "CompanyName",
        "tax_identification_number": "TaxIdentificationNumber",
        "address": "Address",
        "attention_name": "AttentionName",
        "phone": "Phone",
        "e_mail_address": "EMailAddress",
    }
)
class ContactsProducer(BaseModel):
    """Information of the producer. The NAFTA Certificate of Origin must be completed, signed, and dated by the exporter.
    When the Certificate is completed by the producer for use by the exporter, it must be completed, signed, and dated by the producer. The date must be the date the Certificate was completed and signed.  Applies to NAFTA CO.  Required for NAFTA CO forms.

    :param option: The text associated with the code will be printed in the producer section instead of producer contact information.  Use attached List if more than one producer's good is included on the Certificate, attach a list of additional producers, including the legal name, address (including country or territory), and legal tax identification number, cross-referenced to the goods described in the Description of Goods field.  Applies to NAFTA CO.   Valid values:  01 - AVAILABLE TO CUSTOMS UPON REQUEST 02 - SAME AS EXPORTER 03 - ATTACHED LIST 04 - UNKNOWN, defaults to None
    :type option: str, optional
    :param company_name: Company Name or the Individual name of the Producer.  Applies to NAFTA CO.  Only applicable when producer option is empty or not present. Conditionally required for: NAFTA CO, when Producer option is not specified., defaults to None
    :type company_name: str, optional
    :param tax_identification_number: Tax ID of the Producer.  Applies to NAFTA CO. Only applicable when producer option is empty or not present, defaults to None
    :type tax_identification_number: str, optional
    :param address: Address information of the Producer.  Applies to NAFTA CO. Only applicable if producer option is empty or not present. Conditionally required for: NAFTA CO, when Producer option is not specified., defaults to None
    :type address: ProducerAddress, optional
    :param attention_name: Contact name at the Producer location.  Applies to NAFTA CO., defaults to None
    :type attention_name: str, optional
    :param phone: Phone number information of Producer.  Applies to NAFTA CO., defaults to None
    :type phone: ProducerPhone, optional
    :param e_mail_address: Producer email address.  Applies to NAFTA CO., defaults to None
    :type e_mail_address: str, optional
    """

    def __init__(
        self,
        option: str = None,
        company_name: str = None,
        tax_identification_number: str = None,
        address: ProducerAddress = None,
        attention_name: str = None,
        phone: ProducerPhone = None,
        e_mail_address: str = None,
    ):
        if option is not None:
            self.option = option
        if company_name is not None:
            self.company_name = company_name
        if tax_identification_number is not None:
            self.tax_identification_number = tax_identification_number
        if address is not None:
            self.address = self._define_object(address, ProducerAddress)
        if attention_name is not None:
            self.attention_name = attention_name
        if phone is not None:
            self.phone = self._define_object(phone, ProducerPhone)
        if e_mail_address is not None:
            self.e_mail_address = e_mail_address
