# This file was generated by liblab | https://liblab.com/

from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "address_line": "AddressLine",
        "city": "City",
        "state_province_code": "StateProvinceCode",
        "postal_code": "PostalCode",
        "country_code": "CountryCode",
    }
)
class CreditCardAddress(BaseModel):
    """Container to hold the Credit card Billing Address.  It is required to provide billing address if credit card information is provided and when the ShipFrom country or territory is the US, PR, and CA.

    :param address_line: Address Line 1 of the credit card billing address. Usually Street address information.
    :type address_line: List[str]
    :param city: City of the credit card billing address.
    :type city: str
    :param state_province_code: State or province code of the credit card billing address., defaults to None
    :type state_province_code: str, optional
    :param postal_code: Credit card billing addressee postal code., defaults to None
    :type postal_code: str, optional
    :param country_code: Credit card billing address country or territory code. Must be a valid UPS Billing country or territory code.
    :type country_code: str
    """

    def __init__(
        self,
        address_line: List[str],
        city: str,
        country_code: str,
        state_province_code: str = None,
        postal_code: str = None,
    ):
        self.address_line = address_line
        self.city = city
        if state_province_code is not None:
            self.state_province_code = state_province_code
        if postal_code is not None:
            self.postal_code = postal_code
        self.country_code = country_code
