# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"code": "Code", "description": "Description"})
class DdtcInformationUnitOfMeasurement(BaseModel):
    """Container for unit of measurement.  Applies to EEI form only. It is required for EEIFilingOption code 3.

    :param code: Required for EEI form. Unit of measurement code. The two or three (3) alpha unit of measurement for the article being shipped. For example: BAG/BG - bags  Applies to EEI form only.  It is required for EEIFilingOption code 1A and 3.
    :type code: str
    :param description: Description for Unit of Measurement.  Applies to EEI form only., defaults to None
    :type description: str, optional
    """

    def __init__(self, code: str, description: str = None):
        self.code = code
        if description is not None:
            self.description = description
