# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"code": "Code", "description": "Description"})
class DryIceWeightUnitOfMeasurement(BaseModel):
    """Container for Unit of measurement for Dry Ice Weight.

    :param code: DryIce weight unit of measurement code. Valid values: - 00 = KG (Metric Unit of Measurements) or KGS - 01 = LB (English Unit of Measurements) or LBS  The following values are valid : 00, 01, KG, KGS, LBS.
    :type code: str
    :param description: Description for unit of measurement for Dry Ice Weight., defaults to None
    :type description: str, optional
    """

    def __init__(self, code: str, description: str = None):
        self.code = code
        if description is not None:
            self.description = description
