# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .transportation_charges_gross_charge import TransportationChargesGrossCharge
from .transportation_charges_discount_amount import TransportationChargesDiscountAmount
from .transportation_charges_net_charge import TransportationChargesNetCharge


@JsonMap(
    {
        "gross_charge": "GrossCharge",
        "discount_amount": "DiscountAmount",
        "discount_percentage": "DiscountPercentage",
        "net_charge": "NetCharge",
    }
)
class FrsShipmentDataTransportationCharges(BaseModel):
    """Transportation charges container. Ground Freight Pricing transportation charges. These are only returned for Ground Freight Pricing enabled shipper account number when the user includes the FRSShipmentIndicator in the request.

    :param gross_charge: Gross Charges container. It indicates the shipment level gross Ground Freight Pricing transportation charges.
    :type gross_charge: TransportationChargesGrossCharge
    :param discount_amount: Discount Amount container. It indicates the shipment level Ground Freight Pricing discount amount for transportation charges
    :type discount_amount: TransportationChargesDiscountAmount
    :param discount_percentage: It indicates the shipment level discount percentage for transportation charges.
    :type discount_percentage: str
    :param net_charge: Net Charges container. It indicates the shipment level net Ground Freight Pricing transportation charges.
    :type net_charge: TransportationChargesNetCharge
    """

    def __init__(
        self,
        gross_charge: TransportationChargesGrossCharge,
        discount_amount: TransportationChargesDiscountAmount,
        discount_percentage: str,
        net_charge: TransportationChargesNetCharge,
    ):
        self.gross_charge = self._define_object(
            gross_charge, TransportationChargesGrossCharge
        )
        self.discount_amount = self._define_object(
            discount_amount, TransportationChargesDiscountAmount
        )
        self.discount_percentage = discount_percentage
        self.net_charge = self._define_object(
            net_charge, TransportationChargesNetCharge
        )
