# This file was generated by liblab | https://liblab.com/

from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "address_line": "AddressLine",
        "city": "City",
        "state_province_code": "StateProvinceCode",
        "town": "Town",
        "postal_code": "PostalCode",
        "country_code": "CountryCode",
    }
)
class IntermediateConsigneeAddress(BaseModel):
    """Address information of the Intermediate Consignee.  Applicable for EEI form only.

    :param address_line: Address line of the Intermediate Consignee.  Applicable for EEI form only.
    :type address_line: List[str]
    :param city: City of the Intermediate Consignee.  Applicable for EEI form only.
    :type city: str
    :param state_province_code: State of the Intermediate Consignee.  Applicable for EEI form only. Required for certain countries or territories., defaults to None
    :type state_province_code: str, optional
    :param town: Town of the Intermediate consignee.  Applicable for EEI form only., defaults to None
    :type town: str, optional
    :param postal_code: Postal code of the Intermediate Consignee.  Applicable for EEI form only. Required for certain countries or territories. The length of the postal code depends on the country or territory code., defaults to None
    :type postal_code: str, optional
    :param country_code: Country or Territory code of the Intermediate Consignee.  Applicable for EEI form only.
    :type country_code: str
    """

    def __init__(
        self,
        address_line: List[str],
        city: str,
        country_code: str,
        state_province_code: str = None,
        town: str = None,
        postal_code: str = None,
    ):
        self.address_line = address_line
        self.city = city
        if state_province_code is not None:
            self.state_province_code = state_province_code
        if town is not None:
            self.town = town
        if postal_code is not None:
            self.postal_code = postal_code
        self.country_code = country_code
