# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"begin_date": "BeginDate", "end_date": "EndDate"})
class InternationalFormsBlanketPeriod(BaseModel):
    """This field should be entered if the  NAFTA Certificate covers multiple shipments of identical goods as described in the Description of Goods field that are imported into a NAFTA country or territory for a specified period of up to one year (the blanket period). The importation of a good for which preferential treatment is claimed based on this certificate must occur between these dates.  Applies to NAFTA CO form only. Required for NAFTA CO.  This is not valid for a paperless shipment.

    :param begin_date: Begin date of the blanket period. It is the date upon which the Certificate becomes applicable to the good covered by the blanket Certificate (it may be prior to the date of signing this Certificate).  Applies to NAFTA CO form only. Required for NAFTA CO. Format is yyyyMMdd. This is not valid for a paperless shipment.
    :type begin_date: str
    :param end_date: End Date of the blanket period. It is the date upon which the blanket period expires.  Applies to NAFTA CO form only. Required for NAFTA CO. Format is yyyyMMdd.  This is not valid for a paperless shipment.
    :type end_date: str
    """

    def __init__(self, begin_date: str, end_date: str):
        self.begin_date = begin_date
        self.end_date = end_date
