# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"monetary_value": "MonetaryValue"})
class InternationalFormsDiscount(BaseModel):
    """Container tag that holds the discount.  Applies to Invoice and Partial Invoice forms only.

    :param monetary_value: The discount to be subtracted from the sum of the total value on the invoice.  Applies to Invoice and Partial Invoice forms only. Required for Invoice forms and optional for Partial Invoice. Valid characters are 0-9 and '.'  (Decimal point). Limit to 2 digit after the decimal. The maximum length of the field is 15 including '.' and can hold up to 2 decimal places. This value should be greater than or equal to zero or less than or equal to the value of all goods listed on the invoice.
    :type monetary_value: str
    """

    def __init__(self, monetary_value: str):
        self.monetary_value = monetary_value
