# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .eei_filing_option_ups_filed import EeiFilingOptionUpsFiled
from .eei_filing_option_shipper_filed import EeiFilingOptionShipperFiled


@JsonMap(
    {
        "code": "Code",
        "e_mail_address": "EMailAddress",
        "description": "Description",
        "ups_filed": "UPSFiled",
        "shipper_filed": "ShipperFiled",
    }
)
class InternationalFormsEeiFilingOption(BaseModel):
    """EEI Filing option.  Applicable for EEI form and is required.

    :param code: Required for EEI Form.  Applicable for EEI form. Valid values:  1 - Shipper filed, 2 - AES Direct,  3 - UPS filed.
    :type code: str
    :param e_mail_address: Email Address where the notification is sent. Valid for UPS filed (option 3), Shipper filed (option 1- A , 1-C)  Applicable for EEI form., defaults to None
    :type e_mail_address: str, optional
    :param description: Optional Description of Filing Code.  Applicable for EEI form., defaults to None
    :type description: str, optional
    :param ups_filed: Indicates the EEI UPS Filed option. (option 3)  Applicable for EEI form., defaults to None
    :type ups_filed: EeiFilingOptionUpsFiled, optional
    :param shipper_filed: Indicates the EEI Shipper Filed option or AES Direct. (Option 1 or 2).  Applicable for EEI form., defaults to None
    :type shipper_filed: EeiFilingOptionShipperFiled, optional
    """

    def __init__(
        self,
        code: str,
        e_mail_address: str = None,
        description: str = None,
        ups_filed: EeiFilingOptionUpsFiled = None,
        shipper_filed: EeiFilingOptionShipperFiled = None,
    ):
        self.code = code
        if e_mail_address is not None:
            self.e_mail_address = e_mail_address
        if description is not None:
            self.description = description
        if ups_filed is not None:
            self.ups_filed = self._define_object(ups_filed, EeiFilingOptionUpsFiled)
        if shipper_filed is not None:
            self.shipper_filed = self._define_object(
                shipper_filed, EeiFilingOptionShipperFiled
            )
