# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"monetary_value": "MonetaryValue"})
class InternationalFormsInsuranceCharges(BaseModel):
    """Container tag that holds the Insurance Charges.  Applies to Invoice and Partial Invoice forms only.

    :param monetary_value: The amount the shipper or receiver pays to cover the cost of replacing the shipment if it is lost or damaged.  Applies to Invoice and Partial Invoice forms only. Required for Invoice forms and optional for Partial Invoice. Valid characters are 0-9 and '.'  (Decimal point). Limit to 2 digit after the decimal. The maximum length of the field is 15 including '.' and can hold up to 2 decimal places.
    :type monetary_value: str
    """

    def __init__(self, monetary_value: str):
        self.monetary_value = monetary_value
