# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"monetary_value": "MonetaryValue", "description": "Description"})
class InternationalFormsOtherCharges(BaseModel):
    """Container tag that holds the information of amount that covers additional charges not already listed on the invoice.  Applies to Invoice and Partial Invoice forms only.

    :param monetary_value: The Monetary value of Other Charges.  Applies to Invoice and Partial Invoice forms only. Required for Invoice forms and optional for Partial Invoice. Valid characters are 0-9 and '.' (Decimal point). Limit to 2 digit after the decimal. The maximum length of the field is 15 including '.' and can hold up to 2 decimal places.
    :type monetary_value: str
    :param description: Description of what the other charges are for.  Applies to Invoice and Partial Invoice forms only. Required for Complete Invoice and Optional for Partial Invoice forms.
    :type description: str
    """

    def __init__(self, monetary_value: str, description: str):
        self.monetary_value = monetary_value
        self.description = description
