# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .ups_premium_care_form_language_for_ups_premium_care import (
    UpsPremiumCareFormLanguageForUpsPremiumCare,
)


@JsonMap(
    {
        "shipment_date": "ShipmentDate",
        "page_size": "PageSize",
        "print_type": "PrintType",
        "num_of_copies": "NumOfCopies",
        "language_for_ups_premium_care": "LanguageForUPSPremiumCare",
    }
)
class InternationalFormsUpsPremiumCareForm(BaseModel):
    """UPS Premium Care Form is required if UPS Premium Care Indicator is present on a package.  Valid only for Canada to Canada movements.

    :param shipment_date: Shipment Date associated with UPS Premium Care Shipment.   Valid Format: yyyyMMdd
    :type shipment_date: str
    :param page_size: Size of UPS Premium Care Form.  Valid values:  01 = A4 Size 02 = Letter Size
    :type page_size: str
    :param print_type: Format of UPS Premium Care Form.  Valid values:  01 = PNG 02 = PDF
    :type print_type: str
    :param num_of_copies: Number of Copies of UPS Premium Care Form.  Valid value is 02.
    :type num_of_copies: str
    :param language_for_ups_premium_care: Container to hold languages in which UPS Premium Care Form is required.
    :type language_for_ups_premium_care: UpsPremiumCareFormLanguageForUpsPremiumCare
    """

    def __init__(
        self,
        shipment_date: str,
        page_size: str,
        print_type: str,
        num_of_copies: str,
        language_for_ups_premium_care: UpsPremiumCareFormLanguageForUpsPremiumCare,
    ):
        self.shipment_date = shipment_date
        self.page_size = page_size
        self.print_type = print_type
        self.num_of_copies = num_of_copies
        self.language_for_ups_premium_care = self._define_object(
            language_for_ups_premium_care, UpsPremiumCareFormLanguageForUpsPremiumCare
        )
