# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "e_mail_address": "EMailAddress",
        "undeliverable_e_mail_address": "UndeliverableEMailAddress",
        "from_e_mail_address": "FromEMailAddress",
        "from_name": "FromName",
        "memo": "Memo",
        "subject": "Subject",
        "subject_code": "SubjectCode",
    }
)
class LabelDeliveryEMail(BaseModel):
    """Container for the email message.

    :param e_mail_address: The destination eMail address for the Label Delivery.
    :type e_mail_address: str
    :param undeliverable_e_mail_address: The address where an undeliverable email message is sent if the Label Delivery email is undeliverable.  Defaults to FromEMailAddress., defaults to None
    :type undeliverable_e_mail_address: str, optional
    :param from_e_mail_address: The e-mail address specifies the Reply To E-mail address. The "From" field of the message header contains pkginfo@ups.com., defaults to None
    :type from_e_mail_address: str, optional
    :param from_name: The "FrontName" is the name from which notification will appear. Defaults to the "Shipper Name"., defaults to None
    :type from_name: str, optional
    :param memo: User defined text that will be included in the email., defaults to None
    :type memo: str, optional
    :param subject: The eMails subject. Defaults to the Label Delivery Notification plus the shipment ID. Defaults to text provided by UPS., defaults to None
    :type subject: str, optional
    :param subject_code: Specifies a reference code and reference number to display in the subject of the Label Delivery notification. When the subject code is provided, the subject will contain the following: UPS Label Delivery, the reference code (the reference code will be mapped to the corresponding ANSI value) and the reference number. The valid subject codes are: - 01 - Shipment Reference Number 1, - 02 - Shipment Reference Number 2, - 03 - package Reference Number 1, - 04 - package Reference Number 2, - 05 - package Reference Number 3, - 06 - package Reference Number 4, - 07 - package Reference Number 5, - 08 - Subject Text (Return Notification only). If the subject code tag is not provided and the subject text is provided, the subject of the notification will be the subject text. If the subject text is provided, and the subject code tag exists, then the subject code value must be 08. If Subject code is 08, subject text must exist. If a subject code is provided that refers to a nonexistent reference number, the subject will default to the shipment identification number. , defaults to None
    :type subject_code: str, optional
    """

    def __init__(
        self,
        e_mail_address: str,
        undeliverable_e_mail_address: str = None,
        from_e_mail_address: str = None,
        from_name: str = None,
        memo: str = None,
        subject: str = None,
        subject_code: str = None,
    ):
        self.e_mail_address = e_mail_address
        if undeliverable_e_mail_address is not None:
            self.undeliverable_e_mail_address = undeliverable_e_mail_address
        if from_e_mail_address is not None:
            self.from_e_mail_address = from_e_mail_address
        if from_name is not None:
            self.from_name = from_name
        if memo is not None:
            self.memo = memo
        if subject is not None:
            self.subject = subject
        if subject_code is not None:
            self.subject_code = subject_code
