# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "label_link_indicator": "LabelLinkIndicator",
        "resend_e_mail_indicator": "ResendEMailIndicator",
    }
)
class LabelRecoveryRequestLabelDelivery(BaseModel):
    """Container for the Label Delivery accessorial. One Label Delivery per shipment.

    :param label_link_indicator: Indicates the Label Recovery and Receipt Recovery URL links are to be returned in the XML Response. Valid for following shipment - Print/Electronic Return Label Print/Electronic Import Control Label Forward shipment except for Mail Innovations Forward, defaults to None
    :type label_link_indicator: str, optional
    :param resend_e_mail_indicator: Not Used. If this tag is present, resend the Label Delivery notification email., defaults to None
    :type resend_e_mail_indicator: str, optional
    """

    def __init__(
        self, label_link_indicator: str = None, resend_e_mail_indicator: str = None
    ):
        if label_link_indicator is not None:
            self.label_link_indicator = label_link_indicator
        if resend_e_mail_indicator is not None:
            self.resend_e_mail_indicator = resend_e_mail_indicator
