# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .label_recovery_label_specification_label_image_format import (
    LabelRecoveryLabelSpecificationLabelImageFormat,
)
from .label_recovery_label_specification_label_stock_size import (
    LabelRecoveryLabelSpecificationLabelStockSize,
)


@JsonMap(
    {
        "http_user_agent": "HTTPUserAgent",
        "label_image_format": "LabelImageFormat",
        "label_stock_size": "LabelStockSize",
    }
)
class LabelRecoveryRequestLabelSpecification(BaseModel):
    """Container that is used to define the properties required by the user to print and/ or display the UPS shipping label.  Required for the shipment without return service, or shipment with PRL return service.

    :param http_user_agent: Browser HTTPUserAgent String. This is the preferred way of identifying GIF image type to be generated.  Required if <Root node>/ LabelSpecification/LabelImageFormat/Code = Gif. Default to Mozilla/4.5 if this field is missing or has invalid value., defaults to None
    :type http_user_agent: str, optional
    :param label_image_format: The file format of the label and receipt. Defaults to HTML format if this node does not exist., defaults to None
    :type label_image_format: LabelRecoveryLabelSpecificationLabelImageFormat, optional
    :param label_stock_size: Container to hold Label Height and Width information.  Applicable if Label Image Code is ZPL, EPL and SPL. Ignored for other Label Image Code types., defaults to None
    :type label_stock_size: LabelRecoveryLabelSpecificationLabelStockSize, optional
    """

    def __init__(
        self,
        http_user_agent: str = None,
        label_image_format: LabelRecoveryLabelSpecificationLabelImageFormat = None,
        label_stock_size: LabelRecoveryLabelSpecificationLabelStockSize = None,
    ):
        if http_user_agent is not None:
            self.http_user_agent = http_user_agent
        if label_image_format is not None:
            self.label_image_format = self._define_object(
                label_image_format, LabelRecoveryLabelSpecificationLabelImageFormat
            )
        if label_stock_size is not None:
            self.label_stock_size = self._define_object(
                label_stock_size, LabelRecoveryLabelSpecificationLabelStockSize
            )
