# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .tracking_candidate_pickup_date_range import TrackingCandidatePickupDateRange


@JsonMap(
    {
        "tracking_number": "TrackingNumber",
        "destination_postal_code": "DestinationPostalCode",
        "destination_country_code": "DestinationCountryCode",
        "pickup_date_range": "PickupDateRange",
    }
)
class LabelRecoveryResponseTrackingCandidate(BaseModel):
    """Information containing the results of the users Label Recovery Request. Returned in the event the Shipper Number and Reference Number are supplied in the request.

    :param tracking_number: Packaging Tracking Number  Only supported for the web small package shipment so only supported 18 digit
    :type tracking_number: str
    :param destination_postal_code: Destination postal code candidate, defaults to None
    :type destination_postal_code: str, optional
    :param destination_country_code: Destination country or territory code candidate, like US = USA, CA = Canada  Must be valid ups country or territory code, defaults to None
    :type destination_country_code: str, optional
    :param pickup_date_range: A range of time the package was picked up., defaults to None
    :type pickup_date_range: TrackingCandidatePickupDateRange, optional
    """

    def __init__(
        self,
        tracking_number: str,
        destination_postal_code: str = None,
        destination_country_code: str = None,
        pickup_date_range: TrackingCandidatePickupDateRange = None,
    ):
        self.tracking_number = tracking_number
        if destination_postal_code is not None:
            self.destination_postal_code = destination_postal_code
        if destination_country_code is not None:
            self.destination_country_code = destination_country_code
        if pickup_date_range is not None:
            self.pickup_date_range = self._define_object(
                pickup_date_range, TrackingCandidatePickupDateRange
            )
