# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .commodity_nmfc import CommodityNmfc


@JsonMap({"freight_class": "FreightClass", "nmfc": "NMFC"})
class PackageCommodity(BaseModel):
    """Container to hold the Commodity information.  It is required if the Ground Freight Pricing Shipment indicator is present in the request.

    :param freight_class: Freight Classification. Freight class partially determines the freight rate for the article.  Required for Ground Freight Pricing Shipments only.
    :type freight_class: str
    :param nmfc: Container to hold the NMFC codes., defaults to None
    :type nmfc: CommodityNmfc, optional
    """

    def __init__(self, freight_class: str, nmfc: CommodityNmfc = None):
        self.freight_class = freight_class
        if nmfc is not None:
            self.nmfc = self._define_object(nmfc, CommodityNmfc)
