# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .dimensions_unit_of_measurement import DimensionsUnitOfMeasurement


@JsonMap(
    {
        "unit_of_measurement": "UnitOfMeasurement",
        "length": "Length",
        "width": "Width",
        "height": "Height",
    }
)
class PackageDimensions(BaseModel):
    """Dimensions information container. Note: Currently dimensions are not applicable to Ground Freight Pricing.  Length + 2*(Width + Height) must be less than or equal to 165 IN or 330 CM. Required for Heavy Goods service. Package Dimension will be ignored for Simple Rate

    :param unit_of_measurement: UnitOfMeasurement container for dimensions.
    :type unit_of_measurement: DimensionsUnitOfMeasurement
    :param length: Package length. Length must be the longest dimension of the container.  Valid values are 0 to 108 IN and 0 to 270 CM.
    :type length: str
    :param width: Package width.
    :type width: str
    :param height: Package height.
    :type height: str
    """

    def __init__(
        self,
        unit_of_measurement: DimensionsUnitOfMeasurement,
        length: str,
        width: str,
        height: str,
    ):
        self.unit_of_measurement = self._define_object(
            unit_of_measurement, DimensionsUnitOfMeasurement
        )
        self.length = length
        self.width = width
        self.height = height
