# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .shipping_receipt_image_format import ShippingReceiptImageFormat


@JsonMap({"image_format": "ImageFormat", "graphic_image": "GraphicImage"})
class PackageResultsShippingReceipt(BaseModel):
    """Supported for following shipments -
    PRL shipments,
    Electronic Return Label or Electronic Import Control Label shipments with SubVersion greater than or equal to 1707.

    :param image_format: Container for a Image Format.
    :type image_format: ShippingReceiptImageFormat
    :param graphic_image: Base 64 encoded receipt in HTML format. The receipt image is only returned for the first 5 packages.
    :type graphic_image: str
    """

    def __init__(self, image_format: ShippingReceiptImageFormat, graphic_image: str):
        self.image_format = self._define_object(
            image_format, ShippingReceiptImageFormat
        )
        self.graphic_image = graphic_image
