# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .package_service_options_cod_cod_amount import PackageServiceOptionsCodCodAmount


@JsonMap({"cod_funds_code": "CODFundsCode", "cod_amount": "CODAmount"})
class PackageServiceOptionsCod(BaseModel):
    """Container for COD.  Indicates COD is requested. Package level COD is available for shipment without return service from US/PR to US/PR, CA to CA, and CA to US. CA to US COD is not allowed for package Letter/ Envelope. COD is not valid for return service movements.

    :param cod_funds_code: For valid values refer to: Rating and Shipping COD Supported Countries or Territories in the Appendix.
    :type cod_funds_code: str
    :param cod_amount: COD Amount container.
    :type cod_amount: PackageServiceOptionsCodCodAmount
    """

    def __init__(
        self, cod_funds_code: str, cod_amount: PackageServiceOptionsCodCodAmount
    ):
        self.cod_funds_code = cod_funds_code
        self.cod_amount = self._define_object(
            cod_amount, PackageServiceOptionsCodCodAmount
        )
