# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"dcis_type": "DCISType", "dcis_number": "DCISNumber"})
class PackageServiceOptionsDeliveryConfirmation(BaseModel):
    """Delivery Confirmation container.
    Refer to Delivery Confirmation Origin-
    Destination Pairs in the Appendix for a list of valid values.  Valid only for forward shipment only.

    :param dcis_type: Type of delivery confirmation.  Valid values: - 1 - Unsupported - 2 - Delivery Confirmation Signature Required - 3 - Delivery Confirmation Adult Signature Required
    :type dcis_type: str
    :param dcis_number: Delivery Confirmation Control number associated with the delivery confirmation for the package.  Valid for forward shipments only., defaults to None
    :type dcis_number: str, optional
    """

    def __init__(self, dcis_type: str, dcis_number: str = None):
        self.dcis_type = dcis_type
        if dcis_number is not None:
            self.dcis_number = dcis_number
