# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .package_service_options_notification_e_mail import (
    PackageServiceOptionsNotificationEMail,
)


@JsonMap({"notification_code": "NotificationCode", "e_mail": "EMail"})
class PackageServiceOptionsNotification(BaseModel):
    """Receiver Return Notification.  Applicable for Shipment with returned service.

    :param notification_code: Notification Code.  Valid values: 3 - Receiver Return Notification 6 - QV Email Notification 7 - QV Exception Notification 8 - QV Delivery Notification  For Mail Innovations forward shipments, QV Email Notifications are allowed for First Class, Priority Mail, and Expedited Mail Innovation services.
    :type notification_code: str
    :param e_mail: Container for the e-mail message.
    :type e_mail: PackageServiceOptionsNotificationEMail
    """

    def __init__(
        self, notification_code: str, e_mail: PackageServiceOptionsNotificationEMail
    ):
        self.notification_code = notification_code
        self.e_mail = self._define_object(
            e_mail, PackageServiceOptionsNotificationEMail
        )
