# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .ups_premier_handling_instructions import UpsPremierHandlingInstructions


@JsonMap(
    {
        "category": "Category",
        "sensor_id": "SensorID",
        "handling_instructions": "HandlingInstructions",
    }
)
class PackageUpsPremier(BaseModel):
    """UPS Premier Container.

    :param category: UPS Premier Category.  Valid values are 01,02,03 UPS Premier Silver -01 UPS Premier Gold - 02 UPS Premier Platinum - 03
    :type category: str
    :param sensor_id: SensorID is RFID for UPS Premier Silver. SensorID is MeshID for UPS Premier Gold or UPS Premier Platinum Package.
    :type sensor_id: str
    :param handling_instructions: Handling Instruction Container.
    :type handling_instructions: UpsPremierHandlingInstructions
    """

    def __init__(
        self,
        category: str,
        sensor_id: str,
        handling_instructions: UpsPremierHandlingInstructions,
    ):
        self.category = category
        self.sensor_id = sensor_id
        self.handling_instructions = self._define_object(
            handling_instructions, UpsPremierHandlingInstructions
        )
