# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"code": "Code", "description": "Description"})
class PackageWeightUnitOfMeasurement(BaseModel):
    """Container to hold UnitOfMeasurement information for package weight.

    :param code: Package weight unit of measurement code. Valid values: - LBS = Pounds - KGS = Kilograms - OZS = Ounces Unit of Measurement "OZS" is the only valid UOM for some of the Mail Innovations Forward and Worldwide Economy DDU Shipments. Please refer to Appendix for more details regarding the valid combination of Mail Innovation Forward Shipment services, Package Type and Unit of Measurement.
    :type code: str
    :param description: Description of the unit of measurement for package weight., defaults to None
    :type description: str, optional
    """

    def __init__(self, code: str, description: str = None):
        self.code = code
        if description is not None:
            self.description = description
