# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .shipment_charge_bill_shipper import ShipmentChargeBillShipper
from .shipment_charge_bill_receiver import ShipmentChargeBillReceiver
from .shipment_charge_bill_third_party import ShipmentChargeBillThirdParty


@JsonMap(
    {
        "type_": "Type",
        "bill_shipper": "BillShipper",
        "bill_receiver": "BillReceiver",
        "bill_third_party": "BillThirdParty",
        "consignee_billed_indicator": "ConsigneeBilledIndicator",
    }
)
class PaymentInformationShipmentCharge(BaseModel):
    """Shipment charge container.  If Duty and Tax charges are applicable to a shipment and a payer is not specified, the default payer of Duty and Tax charges is Bill to Receiver. There will be no default payer of Duty and Tax charges for DDU and DDP service.

    :param type_: Valid values:  01 = Transportation 02 = Duties and Taxes 03 = Broker of Choice  A shipment charge type of 01 = Transportation is required.  A shipment charge type of 02 = Duties and Taxes is not required; however, this charge type is invalid for Qualified Domestic Shipments.  A Qualified Domestic Shipment is any shipment in which one of the following applies:  1) The origin and destination country or territory is the same. 2) US to PR shipment. 3) PR to US shipment. 4) The origin and destination country or territory are both European Union countries or territories and the GoodsNotInFreeCirculation indicator is not present. 5) The origin and destination IATA code is the same.                                                                                                                                                                                                                                                                                                                                                                                                                                                      03 = Broker of Choice
    :type type_: str
    :param bill_shipper: Container for the BillShipper billing option. The three payment methods that are available for the Bill Shipper billing option are alternate payment method, account number or credit card.  This element or its sibling element, BillReceiver, BillThirdParty or ConsigneeBilledIndicator, must be present but no more than one can be present., defaults to None
    :type bill_shipper: ShipmentChargeBillShipper, optional
    :param bill_receiver: Container for the BillReceiver billing option.  This element or its sibling element, BillShipper, BillThirdParty or Consignee Billed, must be present but no more than one can be present. For a return shipment, Bill Receiver is invalid for Transportation charges., defaults to None
    :type bill_receiver: ShipmentChargeBillReceiver, optional
    :param bill_third_party: Container for the third party billing option.  This element or its sibling element, BillShipper, BillReceiver or Consignee Billed, must be present but no more than one can be present., defaults to None
    :type bill_third_party: ShipmentChargeBillThirdParty, optional
    :param consignee_billed_indicator: Consignee Billing payment option indicator. The presence indicates consignee billing option is selected. The absence indicates one of the other payment options is selected.  This is an empty tag, any value inside is ignored. This element or its sibling element, BillShipper, BillReceiver or BillThirdParty, must be present but no more than one can be present. This billing option is valid for a shipment charge type of Transportation only. Only applies to US/PR and PR/US shipment origins and destination. This payment method allows you to bill the charges for a specified shipment to a consignee who has agreed to pay the charges. All shipping charges are billed to the consignees UPS account number including the following accessorials: Additional Handling, Delivery Area Surcharges, Delivery Change Requests, Early AM Premium, Early AM Out of Territory, Fuel Surcharge, Hazardous Material Surcharges, Large Package Surcharge, Over Max Limits, and Saturday Delivery. Declared Value, Delivery Confirmation, On Call Pickup, Remote Area Surcharge, Saturday Pickup of Delivery fees are not passed to the consignee. These charges are billed to the shippers UPS account number., defaults to None
    :type consignee_billed_indicator: str, optional
    """

    def __init__(
        self,
        type_: str,
        bill_shipper: ShipmentChargeBillShipper = None,
        bill_receiver: ShipmentChargeBillReceiver = None,
        bill_third_party: ShipmentChargeBillThirdParty = None,
        consignee_billed_indicator: str = None,
    ):
        self.type_ = type_
        if bill_shipper is not None:
            self.bill_shipper = self._define_object(
                bill_shipper, ShipmentChargeBillShipper
            )
        if bill_receiver is not None:
            self.bill_receiver = self._define_object(
                bill_receiver, ShipmentChargeBillReceiver
            )
        if bill_third_party is not None:
            self.bill_third_party = self._define_object(
                bill_third_party, ShipmentChargeBillThirdParty
            )
        if consignee_billed_indicator is not None:
            self.consignee_billed_indicator = consignee_billed_indicator
