# This file was generated by liblab | https://liblab.com/

from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"form_type": "FormType"})
class ProductExcludeFromForm(BaseModel):
    """Container tag for determining whether or not to exclude product information from a particular form.  If this container is not present we assume that the DEFAULT is selected which is "none" and all products will appear on all forms.

    :param form_type: Indicates the name of the International form requested to NOT have product information.  Possible Values are 04 – NAFTA CO.  Please note that if this is used and you DO NOT have the corresponding form type requested this will be IGNORED.
    :type form_type: List[str]
    """

    def __init__(self, form_type: List[str]):
        self.form_type = form_type
