# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .unit_unit_of_measurement import UnitUnitOfMeasurement


@JsonMap(
    {"number": "Number", "unit_of_measurement": "UnitOfMeasurement", "value": "Value"}
)
class ProductUnit(BaseModel):
    """Container tag for the Unit information of each product. (also called as commodity)  Required for Invoice forms and optional for Partial Invoice.

    :param number: Total quantity of each commodity to be shipped, measured in the units specified in the Unit of Measure field.  Required for Invoice forms and optional for Partial Invoice. Must be numeric. Valid characters are 0-9.
    :type number: str
    :param unit_of_measurement: Container tag for the Unit of measurement for the commodity.  Required for Invoice forms and optional for Partial Invoice.
    :type unit_of_measurement: UnitUnitOfMeasurement
    :param value: Monetary amount used to specify the worth or price of the commodity. Amount should be greater than zero.  Applies to Invoice and Partial Invoice form. Required for Invoice forms and optional for Partial Invoice. Amount should be greater than zero.  Valid characters are 0-9 and. (Decimal point). Limit to 6 digits after the decimal. The maximum length of the field is 19 including '.' and can hold up to 6 decimal places.(#####.######, ######.#####, #######.####, ########.###, #########.##,##########.#,############). The value of this product  and the other products should be such that the invoice line total which is the sum of ( number*values) of all products should not exceed 9999999999999999.99
    :type value: str
    """

    def __init__(
        self, number: str, unit_of_measurement: UnitUnitOfMeasurement, value: str
    ):
        self.number = number
        self.unit_of_measurement = self._define_object(
            unit_of_measurement, UnitUnitOfMeasurement
        )
        self.value = value
