# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"code": "Code", "description": "Description"})
class ScheduleBUnitOfMeasurement(BaseModel):
    """The unit of measure indicated on the Export License.  Applies to EEI forms only.

    :param code: The unit of measure indicated on the Export License. Enter an X if there is no unit of measure in the Schedule B Unit field.  Applies to EEI forms only. Required for the EEI form. Refer to ScheduleB Unit of Measure Codes in the Appendix for valid values.
    :type code: str
    :param description: Description of the Unit of Measure., defaults to None
    :type description: str, optional
    """

    def __init__(self, code: str, description: str = None):
        self.code = code
        if description is not None:
            self.description = description
