# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"code": "Code", "description": "Description"})
class ShipFromTaxIdType(BaseModel):
    """Tax Identification Container.  Applies to EEI form only.

    :param code: Company's tax Identification type.  Valid values: EIN, DNS, and FGN.  Applies to EEI form only.
    :type code: str
    :param description: Description of TaxID submitted.  Applies to EEI form only., defaults to None
    :type description: str, optional
    """

    def __init__(self, code: str, description: str = None):
        self.code = code
        if description is not None:
            self.description = description
