# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .shipment_request_request import ShipmentRequestRequest
from .shipment_request_shipment import ShipmentRequestShipment
from .shipment_request_label_specification import ShipmentRequestLabelSpecification
from .shipment_request_receipt_specification import ShipmentRequestReceiptSpecification


@JsonMap(
    {
        "request": "Request",
        "shipment": "Shipment",
        "label_specification": "LabelSpecification",
        "receipt_specification": "ReceiptSpecification",
    }
)
class ShipmentRequest(BaseModel):
    """Shipment Request.

    :param request: Request Container
    :type request: ShipmentRequestRequest
    :param shipment: Shipment Container
    :type shipment: ShipmentRequestShipment
    :param label_specification: Container used to define the properties required by the user to print and/or display the UPS shipping label.  Required for shipment without return service or shipments with PRL return service. Required for Electronic Return Label or Electronic Import Control Label shipments with SubVersion greater than or equal to 1707., defaults to None
    :type label_specification: ShipmentRequestLabelSpecification, optional
    :param receipt_specification: Container used to allow the user to choose to print a thermal receipt., defaults to None
    :type receipt_specification: ShipmentRequestReceiptSpecification, optional
    """

    def __init__(
        self,
        request: ShipmentRequestRequest,
        shipment: ShipmentRequestShipment,
        label_specification: ShipmentRequestLabelSpecification = None,
        receipt_specification: ShipmentRequestReceiptSpecification = None,
    ):
        self.request = self._define_object(request, ShipmentRequestRequest)
        self.shipment = self._define_object(shipment, ShipmentRequestShipment)
        if label_specification is not None:
            self.label_specification = self._define_object(
                label_specification, ShipmentRequestLabelSpecification
            )
        if receipt_specification is not None:
            self.receipt_specification = self._define_object(
                receipt_specification, ShipmentRequestReceiptSpecification
            )
