# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .label_specification_label_image_format import LabelSpecificationLabelImageFormat
from .label_specification_label_stock_size import LabelSpecificationLabelStockSize
from .label_specification_instruction import LabelSpecificationInstruction


@JsonMap(
    {
        "label_image_format": "LabelImageFormat",
        "http_user_agent": "HTTPUserAgent",
        "label_stock_size": "LabelStockSize",
        "instruction": "Instruction",
        "character_set": "CharacterSet",
    }
)
class ShipmentRequestLabelSpecification(BaseModel):
    """Container used to define the properties required by the user to print and/or display the UPS shipping label.  Required for shipment without return service or shipments with PRL return service. Required for Electronic Return Label or Electronic Import Control Label shipments with SubVersion greater than or equal to 1707.

    :param label_image_format: LabelImageFormat Container.
    :type label_image_format: LabelSpecificationLabelImageFormat
    :param http_user_agent: Browser HTTPUserAgent String. This is the preferred way of identifying GIF image type to be generated.  Required if /ShipmentRequest/LabelSpecificationLabelSpecification/LabelImageFormat/Code = Gif. Default to Mozilla/4.5 if this field is missing or has invalid value., defaults to None
    :type http_user_agent: str, optional
    :param label_stock_size: Container for the EPL2, ZPL or SPL label size.  Valid for EPL2, ZPL and SPL Labels.
    :type label_stock_size: LabelSpecificationLabelStockSize
    :param instruction: instruction, defaults to None
    :type instruction: List[LabelSpecificationInstruction], optional
    :param character_set: Language character set expected on label. Valid values: dan = Danish (Latin-1) nld = Dutch (Latin-1) fin = Finnish (Latin-1) fra = French (Latin-1) deu = German (Latin-1) itl = Italian (Latin-1) nor = Norwegian (Latin-1) pol  = Polish (Latin-2) por = Poruguese (Latin-1) spa = Spanish (Latin-1)  swe = Swedish (Latin-1)  ces = Czech (Latin-2) hun = Hungarian (Latin-2) slk = Slovak (Latin-2) rus = Russian (Cyrillic) tur = Turkish (Latin-5) ron = Romanian (Latin-2) bul = Bulgarian (Latin-2) est = Estonian (Latin-2) ell = Greek (Latin-2) lav = Latvian (Latin-2) lit = Lithuanian (Latin-2) eng = English (Latin-1)  Default is English (Latin-1)., defaults to None
    :type character_set: str, optional
    """

    def __init__(
        self,
        label_image_format: LabelSpecificationLabelImageFormat,
        label_stock_size: LabelSpecificationLabelStockSize,
        http_user_agent: str = None,
        instruction: List[LabelSpecificationInstruction] = None,
        character_set: str = None,
    ):
        self.label_image_format = self._define_object(
            label_image_format, LabelSpecificationLabelImageFormat
        )
        if http_user_agent is not None:
            self.http_user_agent = http_user_agent
        self.label_stock_size = self._define_object(
            label_stock_size, LabelSpecificationLabelStockSize
        )
        if instruction is not None:
            self.instruction = self._define_list(
                instruction, LabelSpecificationInstruction
            )
        if character_set is not None:
            self.character_set = character_set
