# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .shipment_results_form_image import ShipmentResultsFormImage


@JsonMap(
    {
        "code": "Code",
        "description": "Description",
        "image": "Image",
        "form_group_id": "FormGroupId",
        "form_group_id_name": "FormGroupIdName",
    }
)
class ShipmentResultsForm(BaseModel):
    """Container tag for the International forms image.   Form is returned for following shipments -
    Forward shipments,
    Shipments with PRL ReturnService,
    Electronic Return Label or Electronic Import Control Label shipments with SubVersion greater than or equal to 1707.

    :param code: Code that indicates the type of form. Valid values: 01 - All Requested International Forms.
    :type code: str
    :param description: Description that indicates the type of form. Possible Values. All Requested International Forms.
    :type description: str
    :param image: Container tag for the International forms image., defaults to None
    :type image: ShipmentResultsFormImage, optional
    :param form_group_id: Unique Id for later retrieval of saved version of the completed international forms. Always returned when code = 01. 01 represents international forms., defaults to None
    :type form_group_id: str, optional
    :param form_group_id_name: Contains description text which identifies the group of International forms. This element is part of both request and response. This element does not appear on the forms., defaults to None
    :type form_group_id_name: str, optional
    """

    def __init__(
        self,
        code: str,
        description: str,
        image: ShipmentResultsFormImage = None,
        form_group_id: str = None,
        form_group_id_name: str = None,
    ):
        self.code = code
        self.description = description
        if image is not None:
            self.image = self._define_object(image, ShipmentResultsFormImage)
        if form_group_id is not None:
            self.form_group_id = form_group_id
        if form_group_id_name is not None:
            self.form_group_id_name = form_group_id_name
