# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .notification_e_mail import NotificationEMail
from .notification_voice_message import NotificationVoiceMessage
from .notification_text_message import NotificationTextMessage
from .notification_locale import NotificationLocale


@JsonMap(
    {
        "notification_code": "NotificationCode",
        "e_mail": "EMail",
        "voice_message": "VoiceMessage",
        "text_message": "TextMessage",
        "locale": "Locale",
    }
)
class ShipmentServiceOptionsNotification(BaseModel):
    """Container for the Quantum View Notification (QVN) is valid for all shipments including Return service, Import Control and Returns Flexible Access.  Valid return service types are: ERL, PRL, PNM, RS1, or RS3.   The shipment level notification is valid for forward and return international shipments as well as for domestic shipments (for US and PR).

    :param notification_code: The type of notification requested. Note: - QVN Exception notification and return notification are not applicable to GFP. - QV In-transit and Return Notifications are only valid for ImportControl and Return shipment. - QV In-transit Notification is allowed for return shipments only. - QV Ship Notification is allowed for forward moving shipments only. Valid values: - 5 - QV In-transit Notification - 6 - QV Ship Notification - 7 - QV Exception Notification - 8 - QV Delivery Notification - 2 - Return Notification or Label Creation Notification - 012 - Alternate Delivery Location Notification - 013 - UAP Shipper Notification.
    :type notification_code: str
    :param e_mail: Container for Email Information.
    :type e_mail: NotificationEMail
    :param voice_message: VoiceMessage container is used for specifying phone number for receiving voice Alternate Delivery Location notification and UAP Shipper notification.  Valid only for Alternate Delivery Location notification and UAP Shipper notification. VoiceMessage phone number or TextMessage phone number or email address is required for ADL notification and UAP Shipper notification., defaults to None
    :type voice_message: NotificationVoiceMessage, optional
    :param text_message: TextMessage container is used for specifying phone number for receiving text Alternate Delivery Location notification and UAP Shipper notification.  Valid only for Alternate Delivery Location notification and UAP Shipper notification. VoiceMessage phone number or TextMessage phone number or email address is required for ADL notification and UAP Shipper notification., defaults to None
    :type text_message: NotificationTextMessage, optional
    :param locale: This container is used for providing Language and dialect details for Alternate Delivery Location notifications and UAP Shipper notifications.  Valid only for Alternate Delivery Location notification and UAP Shipper notification., defaults to None
    :type locale: NotificationLocale, optional
    """

    def __init__(
        self,
        notification_code: str,
        e_mail: NotificationEMail,
        voice_message: NotificationVoiceMessage = None,
        text_message: NotificationTextMessage = None,
        locale: NotificationLocale = None,
    ):
        self.notification_code = notification_code
        self.e_mail = self._define_object(e_mail, NotificationEMail)
        if voice_message is not None:
            self.voice_message = self._define_object(
                voice_message, NotificationVoiceMessage
            )
        if text_message is not None:
            self.text_message = self._define_object(
                text_message, NotificationTextMessage
            )
        if locale is not None:
            self.locale = self._define_object(locale, NotificationLocale)
