# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .pre_alert_notification_e_mail_message import PreAlertNotificationEMailMessage
from .pre_alert_notification_voice_message import PreAlertNotificationVoiceMessage
from .pre_alert_notification_text_message import PreAlertNotificationTextMessage
from .pre_alert_notification_locale import PreAlertNotificationLocale


@JsonMap(
    {
        "e_mail_message": "EMailMessage",
        "voice_message": "VoiceMessage",
        "text_message": "TextMessage",
        "locale": "Locale",
    }
)
class ShipmentServiceOptionsPreAlertNotification(BaseModel):
    """This container is used for providing Pre-Alert Notifications to the consignee for UPS Exchange movements and Pack & Collect shipments.

    :param e_mail_message: This container is used for Populating EMailMessage details for PreAlertNotification., defaults to None
    :type e_mail_message: PreAlertNotificationEMailMessage, optional
    :param voice_message: VoiceMessage container is used for specifying phone number for receiving voice PreAlertNotification., defaults to None
    :type voice_message: PreAlertNotificationVoiceMessage, optional
    :param text_message: TextMessage container is used for specifying phone number for receiving text preAlertNotification., defaults to None
    :type text_message: PreAlertNotificationTextMessage, optional
    :param locale: This container is used for providing Language and dialect details for PreAlertNotification.
    :type locale: PreAlertNotificationLocale
    """

    def __init__(
        self,
        locale: PreAlertNotificationLocale,
        e_mail_message: PreAlertNotificationEMailMessage = None,
        voice_message: PreAlertNotificationVoiceMessage = None,
        text_message: PreAlertNotificationTextMessage = None,
    ):
        if e_mail_message is not None:
            self.e_mail_message = self._define_object(
                e_mail_message, PreAlertNotificationEMailMessage
            )
        if voice_message is not None:
            self.voice_message = self._define_object(
                voice_message, PreAlertNotificationVoiceMessage
            )
        if text_message is not None:
            self.text_message = self._define_object(
                text_message, PreAlertNotificationTextMessage
            )
        self.locale = self._define_object(locale, PreAlertNotificationLocale)
