# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"number": "Number", "extension": "Extension"})
class ShipperPhone(BaseModel):
    """Container tag for Phone Number.

    :param number: Shipper's phone Number.  Valid values are 0 - 9. If Shipper country or territory is US, PR, CA, and VI, the layout is: area code, 7 digit PhoneNumber or area code, 7 digit PhoneNumber, 4 digit extension number. For other countries or territories, the layout is: country or territory code, area code, 7 digit number. A phone number is required if destination is international.
    :type number: str
    :param extension: Shipper's phone extension., defaults to None
    :type extension: str, optional
    """

    def __init__(self, number: str, extension: str = None):
        self.number = number
        if extension is not None:
            self.extension = extension
