# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"code": "Code", "description": "Description"})
class UnitUnitOfMeasurement(BaseModel):
    """Container tag for the Unit of measurement for the commodity.  Required for Invoice forms and optional for Partial Invoice.

    :param code: Code for the Unit of measurement of the commodity units.  Required for Invoice forms and optional for Partial Invoice. Refer to Product Unit of Measure Codes in the Appendix for valid values.
    :type code: str
    :param description: The Unit of Measure if OTH (Other) is entered as the UnitOfMeasurement code.  Applies to Invoice and Partial Invoice forms.  Conditionally Required for the Invoice and Partial Invoice form if OTH is entered as the units UnitOfMeasurement Code., defaults to None
    :type description: str, optional
    """

    def __init__(self, code: str, description: str = None):
        self.code = code
        if description is not None:
            self.description = description
